#ifndef __MIPSCOPREG_H__
#define __MIPSCOPREG_H__

#define COP_0_INDEX        $0
#define COP_0_RANDOM       $1
#define COP_0_ENTRYLO0     $2
#define COP_0_ENTRYLO1     $3
#define COP_0_CONF         $3
#define COP_0_CONTEXT      $4
#define COP_0_PAGEMASK     $5
#define COP_0_WIRED        $6
#define COP_0_INFO         $7
#define COP_0_BADVADDR     $8
#define COP_0_COUNT        $9
#define COP_0_ENTRYHI     $10
#define COP_0_COMPARE     $11
#define COP_0_STATUS      $12
#define COP_0_CAUSE       $13
#define COP_0_EPC         $14
#define COP_0_PRID        $15
#define COP_0_CONFIG      $16
#define COP_0_LLADDR      $17
#define COP_0_WATCHLO     $18
#define COP_0_WATCHHI     $19
#define COP_0_XCONTEXT    $20
#define COP_0_FRAMEMASK   $21
#define COP_0_DIAGNOSTIC  $22
#define COP_0_DEBUG       $23
#define COP_0_DEPC        $24
#define COP_0_PERFORMANCE $25
#define COP_0_ECC         $26
#define COP_0_CACHEERR    $27
#define COP_0_TAGLO       $28
#define COP_0_TAGHI       $29
#define COP_0_ERROREPC    $30
#define COP_0_DESAVE      $31

/* Register COP_0_STATUS bit definitions. 
   Only relevant bits are given */
#define STAT_0_KX                  0x00000080
#define STAT_0_NMI                 0x00080000
#define STAT_0_SR                  0x00100000
#define STAT_0_CU0                 0x10000000
#define STAT_0_CU1                 0x20000000
#define STAT_0_CU2                 0x40000000
#define STAT_0_FR		   0x04000000

#ifndef __STR
#define __STR(x) #x
#endif
#ifndef STR
#define STR(x) __STR(x)
#endif

#endif
