#include "mipscopreg.h"
#include "mips-exts.h"
#include "newlib_hooks.h"

extern unsigned char _loadaddr[], _endaddr[], _end[];

void get_mem_info(struct s_mem *mem)
{
	mem->size = _endaddr - _loadaddr;
}

void hardware_init_hook(void)
{
	write_32bit_cp0_register(COP_0_STATUS, STAT_0_CU0 | STAT_0_CU1 | STAT_0_CU2 | STAT_0_KX | STAT_0_FR);
	write_32bit_cp0_register(COP_0_COMPARE, 0);
	write_32bit_cp0_register(COP_0_CAUSE, 0);
	read_64bit_cp0_register_sel(COP_0_OSSCRATCH, 0);
}

/* Exit back to monitor, with the given status code.  */
void hardware_exit_hook(int status)
{
}

int _DEFUN (atexit, (fn), void _EXFUN ((*fn), (void)))
{
	return 0;
}

void  _EXFUN(_exit, (int __status ) _ATTRIBUTE ((noreturn)));

void _DEFUN (exit, (code), int code)
{
	_exit (code);
}
