#!/bin/bash

if [ -z "$1" ] ; then
	echo "specify the dts file as the first argument";
	exit -1;
fi;

dts=$1
dir=`dirname $dts`
file_prefix=`basename $1 .dts`
blob=$dir/../dtb/$file_prefix.dtb
cfg_prefix=$dir/../dtb/$file_prefix-dom

echo "(output blob: $blob), (dir: $dir), (file prefix: $file_prefix)"

for i in 1 2 3
do
	echo "Generating cfg for domain $i:"
	echo "============================="
	./xen-cfg -d $i -b $blob -o $cfg_prefix-$i.cfg
done

exit 0;
