#include "regs.S"

#define LA(t,x) la t,x

	.text
	.align	2
	.globl	_start
	.ent	_start

_start:
	.set	noreorder

	LA (gp, _gp)
	
	.end 	_start

	.globl	__stack

	.ent	zerobss
zerobss:
	LA (v0, _fbss)
	LA (v1, _end)
3:
	sw		zero,0(v0)
	bltu	v0,v1,3b
	addiu	v0,v0,4				# executed in delay slot

	LA (sp, __stack)			# set stack pointer
	.end	zerobss

	.ent	init
init:
	addiu	a1,sp,32			# argv = sp + 32
	addiu	a2,sp,40			# envp = sp + 40
	sw		zero,(a1)			# argv[argc] = 0
	sw		zero,(a2)			# envp[0] = 0
	
	jal		main				# call the program start function
	move	a0,zero				# set argc to 0
1:	b		1b				
	nop
	.end	init

